/* backprop.c */
/* Back Propogation */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

float w03,w04,w05,
      w13,w14,w23,w24,w35,w45,
      act3,act4,act5,
      out3,out4,out5,
      cr3,cr4,cr5,
      beta,r5,error,mse=1;

float sig(float);

main(){

int i,in1,in2,iters;

puts("What is the correction factor?");
scanf("%f",&beta);

puts("How many iterations?");
scanf("%d",&iters);

randomize();

w03=random(1000)/100.0-5.0;
w04=random(1000)/100.0-5.0;
w05=random(1000)/100.0-5.0;
w13=random(1000)/100.0-5.0;
w14=random(1000)/100.0-5.0;
w23=random(1000)/100.0-5.0;
w24=random(1000)/100.0-5.0;
w35=random(1000)/100.0-5.0;
w45=random(1000)/100.0-5.0;


for(i=1;(i<=iters)&&(mse>.01);i++) {
    in1=random(2);
    in2=random(2);
    act3=w13*in1+w23*in2+w03;
    out3=sig(act3);
    act4=w14*in1+w24*in2+w04;
    out4=sig(act4);
    act5=w35*out3+w45*out4+w05;
    out5=sig(act5);
    r5=in1+in2-2.00*in1*in2;
    error=r5-out5;
    mse=mse+.1*(error*error-mse);

    cr5 = error*out5*(1.0-out5);
    w05 = w05+beta*cr5;
    w35 = w35 + (beta*cr5*out3);
    w45 = w45 + (beta*cr5*out4);

    cr3 = w35*cr5*out3*(1.0-out3);
    cr4 = w45*cr5*out4*(1.0-out4);

    w03 = w03 + (beta*cr3);
    w04 = w04 + (beta*cr4);

    w13 = w13 + (beta*cr3*in1);
    w14 = w14 + (beta*cr4*in1);
    w23 = w23 + (beta*cr3*in2);
    w24 = w24 + (beta*cr4*in2);


    printf( "i=%d input= %d %d output=%10.5f  mse=%10.5f\n"
	     ,i,in1,in2,out5,mse);

}  /* end for loop */

/* print out the weights */

printf("\nw03=%10.5f    w13=%10.5f    w23=%10.5f\n",w03,w13,w23);
printf("w04=%10.5f    w14=%10.5f    w24=%10.5f\n",w04,w14,w24);
printf("w05=%10.5f    w35=%10.5f    w45=%10.5f\n",w05,w35,w45);


} /* end main */


float sig(float x)
{   float y;
    y=1.0/(1.0+exp(-x));
    return(y);
}   /* end function sig */
